using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace CSharpSample
{
    #region SatoPrint class declaration    
    public class SatoPrint
    {
	// This file supports all Platforms, but this sample code only supports PDA Platforms
	// so if you want to use this sample code in PC platform, you should create a new project for 
	// PC Platform and add file in your project.
	
        public const string SATODIR = "satoLabel.dll";

        private SatoPrint() { }
        
        [DllImport("coredll.dll", SetLastError = true, EntryPoint = "LoadLibrary")]
        public static extern IntPtr LoadLibrary(string LibName);

        [DllImport("coredll.dll", SetLastError = true, EntryPoint = "FreeLibrary")]
        public static extern Int32 FreeLibrary(IntPtr hLib);
    

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "ConnectPrinter")]
        public static extern Int32 ConnectPrinter(string strPort, Int32 lTimeout);
         
        [DllImport(SATODIR, SetLastError = true, EntryPoint = "DisconnectPrinter")]
        public static extern Int32 DisconnectPrinter();
    

        
        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintDeviceFont")]
        public static extern Int32 PrintDeviceFont(int xPos, int yPOS, int fontName, int xMulti, int yMulti, int rotation, bool bold, 
                                                   string pData);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintVectorFont")]
        public static extern Int32 PrintVectorFont(int xPos, int yPos, int font, int fontWidth, int fontHeight, int rightSpace,
                                                    bool bold, bool reverse, bool italic, int rotation, int alignment, int printDirection,
                                                    string pData);


        [DllImport(SATODIR, SetLastError = true, EntryPoint = "Print1DBarcode")]
        public static extern Int32 Print1DBarcode(int xPos, int yPos, int barcodeType, int narrowBarWidth, int wideBarWidth, int barcodeHeight,
                                                    int rotation, int HRI, string pData);


        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintMaxiCode")]
        public static extern Int32 PrintMaxiCode(int xPos, int yPos, int mode, string barcodeData);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintPDF417")]
        public static extern Int32 PrintPDF417(int xPos, int yPos, int verticalCount, int horizontalCount, int errLevel,
                                                int dataComp, bool HRI, int startPosition, int moduleWidth, int barHeight,
                                                int rotation, string barcodeData);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintQRCode")]
        public static extern Int32 PrintQRCode(int xPos, int yPos, int model, int eccLevel, int barSize, int rotation, string barcodeData);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintDataMatrix")]
        public static extern Int32 PrintDataMatrix(int xPos, int yPos, int barSize, bool reverse, int rotation, string barcodeData);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintAztec")]
        public static extern Int32 PrintAztec(int xPos, int yPos, int barSize, int interpretation, int errCodeNSymbolSize, bool menuSymbol,
                                              int numOfSymbol, int optID, int rotation, string barcodeData);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintCode49")]
        public static extern Int32 PrintCode49(int xPos, int yPos, int narrowWidth, int wideWidth, int barHeight,
                                               int HRI, int startingMode, int rotation, string barcodeData);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintCODELOCK")]
        public static extern Int32 PrintCODELOCK(int xPos, int yPos, int narrowWidth, int wideWidth, int barHeight,
                                                 bool security, int dataColumns, char mode, int encodeRow, string barcodeData);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintMicroPDF")]
        public static extern Int32 PrintMicroPDF(int xPos, int yPos, int moduleWidth, int barHeight, int mode, int rotation, string barcodeData);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintGS1DataBar")]
        public static extern Int32 PrintGS1DataBar(int xPos, int yPos, int barcodeType, int expand, int separatorHeight, int barHeight, int segmentWidth, int rotation, string barcodeData);


        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintBlock")]
        public static extern Int32 PrintBlock(int xStart, int yStart, int xEnd, int yEnd, int option, int thickness);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintCircle")]
        public static extern Int32 PrintCircle(int xPos, int yPos, int size, int multi);


        [DllImport(SATODIR, SetLastError = true, EntryPoint = "PrintImage")]
        public static extern Int32 PrintImage(int xPos, int yPos, string filename, bool dither, bool enableRLE);


        [DllImport(SATODIR, SetLastError = true, EntryPoint = "CheckPrinterStatus")]
        public static extern Int32 CheckPrinterStatus();

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "InitializePrinter")]
        public static extern Int32 InitializePrinter();

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "CalibrateMedia")]
        public static extern Int32 CalibrateMedia();

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "ResetPrinter")]
        public static extern Int32 ResetPrinter();


        [DllImport(SATODIR, SetLastError = true, EntryPoint = "SetCharacterSet")]
        public static extern Int32 SetCharacterSet(int ICS, int codePage);


        [DllImport(SATODIR, SetLastError = true, EntryPoint = "Prints")]
        public static extern Int32 Prints(int nLabelSet, int nCopies);

        [DllImport(SATODIR, SetLastError = true, EntryPoint = "FeedOneLabel")]
        public static extern Int32 FeedOneLabel();
           

        // ##############################################
        

        //Method return value
        public const Int32 BXL_SUCCESS              = 0;
        public const Int32 BXL_READBUFFER_EMPTY     = -1;
        
        public const Int32 BXL_OTHERPTR_OPENED      = -100;
        public const Int32 BXL_NOT_OPENED           = -101;
        public const Int32 BXL_CREATE_ERROR         = -102;
        public const Int32 BXL_CONNECT_ERROR        = -105;
        public const Int32 BXL_NOT_SUPPORT          = -107;
        public const Int32 BXL_BAD_ARGUMENT         = -108;	
        public const Int32 BXL_BUFFER_ERROR	        = -109;
        
        public const Int32 BXL_REGISTRY_ERROR       = -200;
        public const Int32 BXL_WRITE_ERROR          = -300;
        public const Int32 BXL_READ_ERROR           = -301;

        public const Int32 BXL_BITMAPLOAD_ERROR     = -400;
        public const Int32 BXL_BITMAPDATA_ERROR     = -401;


        //Printer Status flag
        public const Int32 BXL_STS_NORMAL = 0;
        public const Int32 BXL_STS_WAITTAKEN = 2;
        public const Int32 BXL_STS_BOARDOVERHEAT = 4;
        public const Int32 BXL_STS_GAPERROR = 8;
        public const Int32 BXL_STS_TPHOVERHEAT = 16;
        public const Int32 BXL_STS_MOTOROVERHEAT = 32;
        public const Int32 BXL_STS_COVEROPEN = 64;
        public const Int32 BXL_STS_PAPEREMPTY = 128;

                    
        //print speed
        public const Int32 BXL_SPEED_25 = 0;
        public const Int32 BXL_SPEED_30 = 1;
        public const Int32 BXL_SPEED_40 = 2;
        public const Int32 BXL_SPEED_50 = 3;
        public const Int32 BXL_SPEED_60 = 4;
        public const Int32 BXL_SPEED_70 = 5;
        public const Int32 BXL_SPEED_80 = 6;

        // print direction
        public const Int32 BXL_TOP_TO_BOTTOM	= 84;
        public const Int32 BXL_BOTTOM_TO_TOP	= 66;

        public const Int32 BXL_LEFT_TO_RIGHT	= 0;
        public const Int32 BXL_RIGHT_TO_LEFT    = 1;


        //media type
        public const Int32 BXL_GAP          = 0;
        public const Int32 BXL_CONTINUOUS   = 1;
        public const Int32 BXL_BLACKMARK    = 2;

        //	Device Fonts
        public const Int32 BXL_ENG_9X15	    = 0;	//	9 x 15
        public const Int32 BXL_ENG_12X20	= 1;	//	12 x 20
        public const Int32 BXL_ENG_16X25	= 2;	//	16 x 25
        public const Int32 BXL_ENG_19X30	= 3;	//	19 x 30
        public const Int32 BXL_ENG_24X38	= 4;	//	24 x 38
        public const Int32 BXL_ENG_32X50	= 5;	//	32 x 50
        public const Int32 BXL_ENG_48X76	= 6;	//	48 x 76
        public const Int32 BXL_ENG_22X34	= 7;	//	22 x 34
        public const Int32 BXL_ENG_28X44	= 8;	//	28 x 44
        public const Int32 BXL_ENG_37X58	= 9;	//  37 x 58 

        public const Int32 BXL_KOR_16X16	= 0x61;	//	16 x 16
        public const Int32 BXL_KOR_24X24	= 0x62;	//	24 x 24	
        public const Int32 BXL_KOR_20X20	= 0x63;	//	20 x 20
        public const Int32 BXL_KOR_26X26	= 0x64;	//	26 x 26
        public const Int32 BXL_KOR_20X26	= 0x65;	//	20 x 26

        public const Int32 BXL_CHN_GB2312	= 0x6D;
        public const Int32 BXL_CHN_BIG5	    = 0x6E;

        // Vector Fonts
        public const Int32 BXL_VECTOR_ASCII	    = 0;
        public const Int32 BXL_VECTOR_KS5601	= 1;
        public const Int32 BXL_VECTOR_BIG5		= 2;
        public const Int32 BXL_VECTOR_GB2312	= 3;
        public const Int32 BXL_VECTOR_JIS		= 4;
        public const Int32 BXL_VECTOR_OCRA		= 5;
        public const Int32 BXL_VECTOR_OCRB      = 6;


        // Rotation
        public const Int32 BXL_ROTATE_0     = 0;
        public const Int32 BXL_ROTATE_90    = 1;
        public const Int32 BXL_ROTATE_180   = 2;
        public const Int32 BXL_ROTATE_270   = 3;

        // alignment
        public const Int32 BXL_ALIGNMENT_LEFT   = 0;
        public const Int32 BXL_ALIGNMENT_CENTER = 1;
        public const Int32 BXL_ALIGNMENT_RIGHT  = 2;

        
        // 1D Barcode
        public const Int32 BXL_1DBAR_CODE39     = 0;
        public const Int32 BXL_1DBAR_CODE128	= 1;
        public const Int32 BXL_1DBAR_I2OF5		= 2;
        public const Int32 BXL_1DBAR_CODABAR	= 3;
        public const Int32 BXL_1DBAR_CODE93		= 4;
        public const Int32 BXL_1DBAR_UPCA		= 5;
        public const Int32 BXL_1DBAR_UPCE		= 6;
        public const Int32 BXL_1DBAR_EAN13		= 7;
        public const Int32 BXL_1DBAR_EAN8		= 8;
        public const Int32 BXL_1DBAR_EAN128		= 9;


        // 2D Barcode
        // MAXICODE
        public const Int32 BXL_MAXICODE_MODE0 = 0;
        public const Int32 BXL_MAXICODE_MODE2 = 2;
        public const Int32 BXL_MAXICODE_MODE3 = 3;
        public const Int32 BXL_MAXICODE_MODE4 = 4;

        // PDF417
        public const Int32 BXL_PDF417_ECL0	= 0;
        public const Int32 BXL_PDF417_ECL1	= 1;
        public const Int32 BXL_PDF417_ECL2	= 2;
        public const Int32 BXL_PDF417_ECL3	= 3;
        public const Int32 BXL_PDF417_ECL4	= 4;
        public const Int32 BXL_PDF417_ECL5	= 5;
        public const Int32 BXL_PDF417_ECL6	= 6;
        public const Int32 BXL_PDF417_ECL7	= 7;
        public const Int32 BXL_PDF417_ECL8	= 8;

        public const Int32 BXL_PDF417_COMP_TEXT	    = 0;
        public const Int32 BXL_PDF417_COMP_NUM		= 1;
        public const Int32 BXL_PDF417_COMP_BINARY   = 2;

        // QR Code ECC Level
        public const Int32 BXL_QRCODE_ECC7		= 0;
        public const Int32 BXL_QRCODE_ECC15	    = 1;
        public const Int32 BXL_QRCODE_ECC25	    = 2;
        public const Int32 BXL_QRCODE_ECC30	    = 3;

        // CODABLOCK 
        public const Int32 BXL_CODABLOCK_A		= 0;
        public const Int32 BXL_CODABLOCK_E		= 1;
        public const Int32 BXL_CODABLOCK_F		= 2;

        // GS1 DataBar
        public const Int32 BXL_GS1DATABAR           = 0;
        public const Int32 BXL_GS1DATABAR_TRUNCATED = 1;
        public const Int32 BXL_GS1DATABAR_STACKED   = 2;
        public const Int32 BXL_GS1DATABAR_STACKED_OMNIDIRECTIONAL = 3;
        public const Int32 BXL_GS1DATABAR_LIMITED   = 4;
        public const Int32 BXL_GS1DATABAR_EXPANDED  = 5;


        // Draw Block
        public const Int32 BXL_BLOCK_OVERWRITE      = 0;
        public const Int32 BXL_BLOCK_EXCLUSIVEOR	= 1;
        public const Int32 BXL_BLOCK_DELETE		    = 2;
        public const Int32 BXL_BLOCK_SLOPE			= 3;
        public const Int32 BXL_BLOCK_BOX			= 4;	

        
        // International Character Set
        public const Int32 BXL_ICS_USA			= 0;
        public const Int32 BXL_ICS_FRANCE		= 1;
        public const Int32 BXL_ICS_GERMANY		= 2;
        public const Int32 BXL_ICS_UK			= 3;
        public const Int32 BXL_ICS_DENMARK_I	= 4;
        public const Int32 BXL_ICS_SWEDEN		= 5;
        public const Int32 BXL_ICS_ITALY		= 6;
        public const Int32 BXL_ICS_SPAIN_I		= 7;
        public const Int32 BXL_ICS_NORWAY		= 8;
        public const Int32 BXL_ICS_DENMARK_II   = 9;	
        public const Int32 BXL_ICS_JAPAN		= 10;
        public const Int32 BXL_ICS_SPAIN_II	    = 11;	
        public const Int32 BXL_ICS_LATIN		= 12;	
        public const Int32 BXL_ICS_KOREA		= 13;	
        public const Int32 BXL_ICS_SLOVENIA	    = 14;
        public const Int32 BXL_ICS_CHINA		= 15;


        // Code Page
        public const Int32 BXL_CS_CP437			= 0;
        public const Int32 BXL_CS_CP850			= 1;
        public const Int32 BXL_CS_CP852			= 2;
        public const Int32 BXL_CS_CP860			= 3;
        public const Int32 BXL_CS_CP863			= 4;
        public const Int32 BXL_CS_CP865			= 5;
        public const Int32 BXL_CS_WCP1252		= 6;
        public const Int32 BXL_CS_CP865_WCP1252	= 7;
        public const Int32 BXL_CS_CP857			= 8;
        public const Int32 BXL_CS_CP737			= 9;
        public const Int32 BXL_CS_WCP1250		= 10;
        public const Int32 BXL_CS_WCP1253		= 11;
        public const Int32 BXL_CS_WCP1254		= 12;
        public const Int32 BXL_CS_CP855			= 13;
        public const Int32 BXL_CS_CP862			= 14;
        public const Int32 BXL_CS_CP866			= 15;
        public const Int32 BXL_CS_WCP1251		= 16;
        public const Int32 BXL_CS_WCP1255		= 17;
        public const Int32 BXL_CS_CP928			= 18;
        public const Int32 BXL_CS_CP864			= 19;
        public const Int32 BXL_CS_CP775			= 20;
        public const Int32 BXL_CS_WCP1257		= 21;
        public const Int32 BXL_CS_CP858         = 22;
        public const Int32 BXL_CS_CP874         = 23;
        public const Int32 BXL_CS_CP1256        = 24;
	
    }

    #endregion

}
